use strict;
use warnings;

package SimpleCMS::Model::Content;
use Jifty::DBI::Schema;

use SimpleCMS::Model::Page;
use SimpleCMS::Model::PageCollection;
# use Scalar::Defer;

use SimpleCMS::Record schema {
    column page_id =>
        type is 'int',
        label is 'Page ID',
        refers_to SimpleCMS::Model::Page by 'id',
        # render_as 'Text',
        sort_order is -1,
        render as 'Select',
        since '0.0.1';

    column headline =>
        type is 'text',
        label is 'Headline',
        render_as 'Text',
        since '0.0.1';

    column content =>
        type is 'text',
        label is 'Content',
        render_as 'Textarea',
        mandatory,
        since '0.0.1';
};

# Your model-specific methods go here.

#
# a bad back :-(
# scan through all pages to get the Select-Box filled
#
my $select_filled;
sub after_page_id {
    my $self = shift;

    return if ($select_filled++);

    my @result = ();
    my $pages = SimpleCMS::Model::PageCollection->new();
    $pages->unlimit();
    $pages->order_by(column => 'id');
    while (my $page = $pages->next) {
        push @result, {display => $page->name,
                       value   => $page->id};
    }

    $self->COLUMNS->{page_id}->{valid_values} = \@result;
}

sub current_user_can {
    my $self = shift;
    my $right = shift;
    my $extra = shift || '';
    my $extra2 = shift || '';

    # warn "Content: right=$right, extra=$extra $extra2";
    return 1;
}


1;

